Subject: bug#71300: [PATCH v4] doc: Document SRFI 64.

From: Maxime Devos <[email-masked]>
Date: Sun, 29 Sep 2024 21:43:37 +0200

>> Based on this I believe it describes the specification.
>
>That's correct. It's been slightly modified in places where it said
>things like "left to the implementation" and I was able to verify what
>the current implementation in Guix does.

I assume Guix->Guile.

This modification of “left to the implementation” -> “what Guile does” is problematic, since it misleads readers into thinking this is the standard behaviour (it is after all named SRFI 64, not GRFI 64).

“What Guile does” is also important information to have.

To avoid this problem, when it documents a choice made by Guile, it should indicate in some way that this is Guile behaviour.
(E.g.: “It is left to the implementation what happens when A. Guile chooses to B.”, or “It is left to the implementation what happens when A. Guile currently chooses to B, but may choose differently in future versions.”)

>> I think either of those is fine (albeit describing the Guile's flavor
>> would be preferred), but is should be stated (that the behavior
>There's not really a Guile flavor; it's more like the reference
implementation flavor ;-).  The one in Guile is pretty stock.

Then Guile flavour is stock flavour, and stock flavour isn’t specification vanilla. From what I’ve heard, it’s not just sprinkles added to vanilla, it also has bugs (not the crunchy food kind).

>> described by the manual does not match the implementation shipped).
>I'd consider different behavior in the implementation compared to the
specification bugs.

See response by Taylan Kammer.

Best regards,
Maxime Devos